import java.lang.reflect.*;

public class House {
   // Primary key attributes
   String  ownerName;
   int     houseId;

   // one-to-one relationship with address attribute
   Address address;

   // other (basic) attributes
   float   area;
   int     vintage;


   // The no-argument constructor, reqd by dbMapper
   public House() {
   }

   // Other constructors
   public House (String ownerName, int houseId, float area, int vintage,
                 Address address) {
      this.ownerName = ownerName;
      this.houseId = houseId;
      this.area = area;
      this.vintage = vintage;
      this.address = address;
   }


   // Getter/Setter methods for attributes
   public String getOwnerName () { return ownerName; }
   public int getHouseId () { return houseId; }
   public float  getArea () { return area; }
   public int    getVintage () { return vintage; }
   public Address getAddress () { return address; }

   public void setOwnerName (String ownerName) { this.ownerName = ownerName; }
   public void setHouseId (int houseId) { this.houseId = houseId; }
   public void setArea (float area) { this.area = area; }
   public void setVintage (int vintage) { this.vintage = vintage; }
   public void setAddress (Address address) { this.address = address; }


   public String toString() {
      java.util.Hashtable h = new java.util.Hashtable();
      Class cls = getClass();
      Field[] fields = cls.getDeclaredFields();
      //AccessibleObject.setAccessible(fields, true);
      for(int i=0; i<fields.length; i++) {
         try {
            h.put(fields[i].getName(), fields[i].get(this) + "\n");
         }
         catch(IllegalAccessException e) {}
      }    
      if(cls.getSuperclass().getSuperclass() != null) {
         h.put("super", super.toString());
      }
      return cls.getName() + "\n" + h;
   }

}
